{-# LANGUAGE CPP #-}
{-| 
    Module      :  Main
    Description :  laucher for approximated exact real arithmetic tests
    Copyright   :  (c) Michal Konecny
    License     :  BSD3

    Maintainer  :  mik@konecny.aow.cz
    Stability   :  experimental
    Portability :  portable

    An executable for easy automated launch of tests 
    of approximated exact real arithmetic.
-}
module Main where

import qualified Data.Number.ER.Real.Approx as RA
import Data.Number.ER.Real.Approx.Tests.Run 
import Data.Number.ER.Real.DefaultRepr

--import Data.Number.ER.Real.Approx.Tests.Properties
--import Data.Number.ER.Real.Approx.Tests.Generate

main =
    do
    runRATests "interval-double" sampleRABM (RA.initialiseBaseArithmetic sampleRABM)
    runRATests "interval-haskell" sampleRABM (RA.initialiseBaseArithmetic sampleRABAP)
    runRATests "interval-haskell-double" sampleRABM (RA.initialiseBaseArithmetic sampleRABMAP)
#ifdef USE_MPFR
    runRATests "interval-mpfr" sampleRABM (RA.initialiseBaseArithmetic sampleRABMPFR)
#endif

sampleRABM :: RA BM
sampleRABAP :: RA BAP
sampleRABMAP :: RA BMAP
sampleRABM = 0
sampleRABAP = 0
sampleRABMAP = 0

#ifdef USE_MPFR
sampleRABMPFR :: RA BMPFR
sampleRABMPFR = 0
#endif